export declare type Effects = {
    [key: string]: any;
};
export declare type BatchEffects = [Effects];
export interface StateWithFx<S> {
    state: S;
    effects: Effects | BatchEffects;
}
export declare class StateWithFx<S> {
    constructor(state: S, effects: Effects);
}
export declare function hasFX<S>(s: S | StateWithFx<S>): s is StateWithFx<S>;
export declare function fx<S>(state: S, effects: Effects): StateWithFx<S>;
