import 'babel-polyfill';
import { fx, StateWithFx } from './helpers';
import { StoreEnhancerStoreCreator, Store, StoreEnhancer, Action, Dispatch } from 'redux';
export interface FXReducer<S, A> {
    (state: S | undefined, action: A): S | StateWithFx<S>;
}
export interface FXHandler<S> {
    (params: FXParams, getState: () => S, dispatch: Dispatch<S>): void;
}
export interface FXParams {
    [key: string]: any;
}
export interface FXStore<S> extends Store<S> {
    registerFX(id: string, handler: FXHandler<S>): void;
}
declare const reduxDataFX: <S, A extends Action>(createStore: StoreEnhancerStoreCreator<S>) => (reducer: FXReducer<S, A>, initialState: S) => FXStore<S>;
export interface StoreCreator {
    <S, A extends Action>(reducer: FXReducer<S, A>, enhancer?: StoreEnhancer<S>): FXStore<S>;
    <S, A extends Action>(reducer: FXReducer<S, A>, preloadedState: S, enhancer?: StoreEnhancer<S>): FXStore<S>;
}
declare const createStoreFx: StoreCreator;
export { reduxDataFX, fx, createStoreFx as createStore };
